using CommunityToolkit.Mvvm.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using CtrEditor.FuncionesBase;
using System.ComponentModel;


namespace CtrEditor.ObjetosSim
{
    /// <summary>
    /// Interaction logic for ucConsensGeneric.xaml
    /// </summary>
    public partial class osConsensGeneric : osBase, IosBase
    {

        public TagsConsensos Consensos = new TagsConsensos();

        [ObservableProperty]
        [property: Category("Datos")]
        [property: Description("Lista de tags para consenso")]
        [property: Name("Tags")]
        public List<string> tags;

        // Otros datos y métodos relevantes para la simulación

        public static string NombreClase()
        {
            return "Consenso Genérico";
        }

        public static string NombreCategoria()
        {
            return "TagsSignals";
        }
        private string nombre = NombreClase();

        [property: Category("Identificación")]
        [property: Description("Nombre identificativo del objeto")]
        [property: Name("Nombre")]
        public override string Nombre
        {
            get => nombre;
            set => SetProperty(ref nombre, value);
        }

        [ObservableProperty]
        [property: Category("Configuración")]
        [property: Description("Tamaño del consenso")]
        [property: Name("Tamaño")]
        public float tamano;

        public override void OnResize(float Delta_Width, float Delta_Height)
        {
            Tamano += Delta_Width + Delta_Height;
        }

        public override void ucLoaded()
        {
            // El UserControl ya se ha cargado y podemos obtener las coordenadas para 
            // crear el objeto de simulacion
            base.ucLoaded();

            //if (_visualRepresentation is ucConsensGeneric uc)
            //    Tags = UserControlFactory.CargarPropiedadesosDatosTags(Consensos, uc.PanelEdicion, null);

        }
    }

    public partial class ucConsensGeneric : UserControl, IDataContainer
    {
        public osBase? Datos { get; set; }
        public int zIndex_fromFrames { get; set; }

        public ucConsensGeneric()
        {
            InitializeComponent();
            this.Loaded += OnLoaded;
            this.Unloaded += OnUnloaded;
        }
        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucLoaded();
        }
        private void OnUnloaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucUnLoaded();
        }
        public void Highlight(bool State) { }
        public ZIndexEnum ZIndex_Base()
        {
            return ZIndexEnum.Estaticos;
        }

    }

    public class TagsConsensos
    {
        public string Tag { get; set; }
        public bool Consenso_Uscita { get; set; }
        public string Velocidad { get; set; }
    }

}

